CREATE OR REPLACE PACKAGE UTILIDADES AS

  PROCEDURE LOGS_Add( p_nompro           IN     LOGS.NOMPRO%TYPE
                     ,p_logpar           IN     LOGS.LOGPAR%TYPE
                     ,p_tiplog           IN     LOGS.TIPLOG%TYPE
                     ,p_conf             IN     VARCHAR2 DEFAULT 'S'
                     ,p_RSP              IN     VARCHAR2);
-- Sobrecarga de funciones --  
  FUNCTION PAISES_Found(p_busca IN PAISES.COD%TYPE)
  RETURN VARCHAR2;

  FUNCTION PERSONAS_Found(p_ide IN PERSONAS.IDE%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION PERSONAS_Found(p_id IN PERSONAS.ID%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION PERSONAS_GetNomComp(p_id IN PERSONAS.ID%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION PERSONAS_GetEdad(p_id IN PERSONAS.ID%TYPE)
  RETURN INTEGER;
  
  FUNCTION CIUDADANOS_Found(p_idpersona IN PERSONAS.ID%TYPE
                            ,p_idcentro IN CENTROS_SALUD.ID%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION CIUDADANOS_Found(p_id IN CIUDADANOS.ID%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION CIUDADANOS_GetID(p_idpersona IN PERSONAS.ID%TYPE
                            ,p_idcentro IN CENTROS_SALUD.ID%TYPE)
  RETURN CIUDADANOS.ID%TYPE;
    
  FUNCTION CIUDADANOS_GetNomComp(p_id IN CIUDADANOS.ID%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION CIUDADANOS_GetEdad(p_id IN CIUDADANOS.ID%TYPE)
  RETURN INTEGER;
  
   FUNCTION CIUDADANOS_GetPais(p_idciu IN CIUDADANOS.ID%TYPE)
  RETURN PAISES.COD%TYPE;
    
  FUNCTION CENTROS_SALUD_Found( p_id IN CENTROS_SALUD.ID%TYPE)
  RETURN VARCHAR2; 
  
  FUNCTION CENTROS_SALUD_Found(p_codpais IN CENTROS_SALUD.CODPAIS%TYPE
                              ,p_codcentro IN CENTROS_SALUD.CODCENTRO%TYPE)
  RETURN VARCHAR2;
  FUNCTION MOTIVOS_BAJA_Found(p_id IN MOTIVOS_BAJA.ID%TYPE)
  RETURN VARCHAR2;
 
  FUNCTION ACT_DIARIA_Found(p_idciu IN ACT_DIARIA.IDCIU%TYPE
                           ,p_fecha IN ACT_DIARIA.FECHA%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION ACT_DIARIA_GetRow(p_idciu IN ACT_DIARIA.IDCIU%TYPE
                            ,p_fecha IN ACT_DIARIA.FECHA%TYPE)
  RETURN ACT_DIARIA%ROWTYPE;
  
  FUNCTION HIS_SALUD_Found(p_idciu IN HIS_SALUD.IDCIU%TYPE
                          ,p_anio IN HIS_SALUD.ANIO%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION HIS_SALUD_Found(p_id IN HIS_SALUD.ID%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION HIS_SALUD_GetAnio(p_id IN HIS_SALUD.ID%TYPE)
  RETURN HIS_SALUD.ANIO%TYPE;
  
  FUNCTION HIS_SALUD_GetIdCiu(p_id IN HIS_SALUD.ID%TYPE)
  RETURN HIS_SALUD.IDCIU%TYPE;  
  
  FUNCTION HIS_SALUD_GetRow(p_idciu IN HIS_SALUD.IDCIU%TYPE
                           ,p_anio IN HIS_SALUD.ANIO%TYPE)
  RETURN HIS_SALUD%ROWTYPE;
  
  FUNCTION HIS_SALUD_GetRow(p_id IN HIS_SALUD.ID%TYPE)
  RETURN HIS_SALUD%ROWTYPE;
  
  FUNCTION HISSALUD_ENF_Found(p_idhis IN HIS_SALUD.ID%TYPE
                             ,p_idenf IN ENFERMEDADES.ID%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION ENFERMEDADES_Found(p_id IN ENFERMEDADES.ID%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION ENFERMEDADES_Found(p_colest IN ENFERMEDADES.COLEST%TYPE)
  RETURN VARCHAR2;
  
  FUNCTION ENFERMEDADES_GetByID(p_id IN ENFERMEDADES.ID%TYPE)
  RETURN ENFERMEDADES.DENOM%TYPE;
  
  FUNCTION ENFERMEDADES_GetColEst(p_id IN ENFERMEDADES.ID%TYPE)
  RETURN ENFERMEDADES.COLEST%TYPE;
  
  
  FUNCTION EST_ANU_PAI_SALUD_GetID(p_anio IN EST_ANU_PAI_SALUD.ANIO%TYPE 
                                 , p_codpais IN EST_ANU_PAI_SALUD.CODPAIS%TYPE)
  RETURN EST_ANU_PAI_SALUD.ID%TYPE;

  FUNCTION EST_ANU_SALUD_GetID(p_anio IN EST_ANU_SALUD.ANIO%TYPE)
  RETURN EST_ANU_SALUD.ID%TYPE;  
  
  FUNCTION ERRORES_GetByID(p_id IN ERRORES.ID%TYPE)
  RETURN ERRORES.DESCRIP%TYPE;

END UTILIDADES;
/
CREATE OR REPLACE PACKAGE BODY UTILIDADES AS

/*******************************************************************************
   *  Descripcin: Realiza el alta en la tabla  LOGS de la BD.
   *  Parametros entrada:
   *   - p_nompro - Nombre de procedimiento que realiza la accin
   *   - p_logpar - Nombre y valor de parametros de entrada / salida
   *   - p_tiplog - Tipo de log ['I'=Inicio procedimiento | 'F'=Fin procedimiento]
   *   - p_conf   - ['S'=Si confirma insert | 'N'=No confirma insert]
   *
   *  Parametro de salida: p_RSP
   *      Contiene:
   *                'OK' - > si la ejecucin ha sido correcta
   *                'ERROR '+ TIPO DE ERROR -> si la ejecucin es erronea
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         29-10-2014  Creacin procedimiento    
   ****************************************************************************/

 PROCEDURE LOGS_Add( p_nompro             IN     LOGS.NOMPRO%TYPE
                   ,p_logpar             IN     LOGS.LOGPAR%TYPE
                   ,p_tiplog             IN     LOGS.TIPLOG%TYPE
                   ,p_conf               IN     VARCHAR2 DEFAULT 'S'
                   ,p_RSP                IN     VARCHAR2)
    IS
      -- Declaracin de variables          
      v_err_msg             VARCHAR2 (256);
      v_err_num             NUMBER;
      v_RSP                 VARCHAR2(500);     

   BEGIN
     
      INSERT INTO LOGS(NOMPRO, LOGPAR, TIPLOG , RSP)
         VALUES (p_nompro, p_logpar, p_tiplog, p_RSP);
      
      IF p_conf='S' THEN   
         COMMIT;            
      END IF;
      
   EXCEPTION
      WHEN OTHERS THEN
         v_err_num := SQLCODE;
         v_RSP := SUBSTR (SQLERRM, 1, 100);
         v_RSP := 'ERROR ' || TO_CHAR (v_err_num) || ' - [SQLERR] ' || v_err_msg;
         DBMS_OUTPUT.PUT_LINE (v_RSP);
   END LOGS_Add;     

  /* ***************************************************************************
   *  Descripcin: Busca pais en tabla PAISES
   *  Parametro entrada:
   *      p_busca = Elemento a buscar
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         29-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION PAISES_Found(p_busca IN PAISES.COD%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT COD FROM PAISES
      WHERE HAB='S' 
        AND COD = p_busca;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
  RETURN v_fnd;
  END PAISES_Found;
  
  /* ***************************************************************************
   *  Descripcin: Busca por IDE (identificador de persona) en tabla PERSONAS
   *  Parametro entrada:
   *      p_ide = Identificador a buscar
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         29-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION PERSONAS_Found(p_ide IN PERSONAS.IDE%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT IDE FROM PERSONAS
      WHERE FECHABAJ IS NULL
        AND IDE = p_ide;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END PERSONAS_Found;
  /* ***************************************************************************
   *  Descripcin: Busca ID de persona en tabla PERSONAS
   *  Parametro entrada:
   *      p_id = Identificador a buscar
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         30-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION PERSONAS_Found(p_id IN PERSONAS.ID%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT ID FROM PERSONAS
      WHERE FECHABAJ IS NULL
        AND ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END PERSONAS_Found;
  /* ***************************************************************************
   *  Descripcin: Devuelve el nombre completo de la persona
   *  Parametro entrada:
   *      p_id = Identificador a buscar
   *  Devuelve una cadena con nombre completo
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         23-11-2014  Creacin funcin    
   ****************************************************************************/
  FUNCTION PERSONAS_GetNomComp(p_id IN PERSONAS.ID%TYPE)
  RETURN VARCHAR2 
  IS
  CURSOR c_bus IS
    SELECT NOMBRE || ' ' || APELLIDO1 || ' ' || APELLIDO2 nomcomp FROM PERSONAS
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(80);
  BEGIN
   v_fnd:= NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= v_bus.nomcomp;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
   END PERSONAS_GetNomComp;
    /* ***************************************************************************
   *  Descripcin: Devuelve la edad de una persona
   *  Parametro entrada:
   *      p_id = Identificador a buscar
   *  Devuelve una edad de persona
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         24-11-2014  Creacin funcin    
   ****************************************************************************/
  FUNCTION PERSONAS_GetEdad(p_id IN PERSONAS.ID%TYPE)
  RETURN INTEGER 
  IS
  CURSOR c_bus IS
    SELECT FECHANAC
    FROM PERSONAS
     WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  NUMBER;
  BEGIN
   v_fnd:= NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= (MONTHS_BETWEEN (TRUNC(SYSDATE)
                    ,TRUNC(v_bus.FECHANAC)))/12;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
   END PERSONAS_GetEdad;
   /* ***************************************************************************
   *  Descripcin: Busca identificador de ciudadano en tabla CIUDADANOS
   *  Parametro entrada:
   *      p_idpersona = Identificador  de persona 
   *      p_idcentro  = Identificador de centro
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         29-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION CIUDADANOS_Found(p_idpersona IN PERSONAS.ID%TYPE
                          ,p_idcentro IN CENTROS_SALUD.ID%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT ID FROM CIUDADANOS
      WHERE FECHABAJ IS NULL
        AND IDPERSONA = p_idpersona
        AND IDCENTRO = p_idcentro;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END CIUDADANOS_Found;
 /* ***************************************************************************
   *  Descripcin: Busca ID de ciudadano en tabla CIUDADANOS
   *  Parametro entrada:
   *      p_id = Identificador a buscar
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         04-11-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION CIUDADANOS_Found(p_id IN CIUDADANOS.ID%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT ID FROM CIUDADANOS
      WHERE FECHABAJ IS NULL
        AND ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END CIUDADANOS_Found;
  
   /* ***************************************************************************
   *  Descripcin: Devuelve identificador de registro de tabla CIUDADANOS
   *  Parametro entrada:
   *      p_idpersona = Identificador de persona 
   *      p_idcentro  = Identificador de centro
   *  Devuelve identificador de ciudadano en la BD
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         29-10-2014  Creacin funcin    
   ****************************************************************************/
   FUNCTION CIUDADANOS_GetID(p_idpersona IN PERSONAS.ID%TYPE
                            ,p_idcentro IN CENTROS_SALUD.ID%TYPE)
  RETURN CIUDADANOS.ID%TYPE IS

  CURSOR c_bus IS
    SELECT ID fnd FROM CIUDADANOS
      WHERE FECHABAJ IS NULL
        AND IDPERSONA = p_idpersona
        AND IDCENTRO = p_idcentro;
  v_bus  c_bus%ROWTYPE;
  v_fnd  CIUDADANOS.ID%TYPE;
  BEGIN
   v_fnd:=null;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:=v_bus.fnd;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END CIUDADANOS_GetID;
  
  /* ***************************************************************************
   *  Descripcin: Devuelve el nombre completo de ciudadano
   *  Parametro entrada:
   *      p_id = Identificador a buscar
   *  Devuelve una cadena con nombre completo de tiudad
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         23-11-2014  Creacin funcin    
   ****************************************************************************/
  
  FUNCTION CIUDADANOS_GetNomComp(p_id IN CIUDADANOS.ID%TYPE)
   RETURN VARCHAR2 
  IS
  CURSOR c_bus IS
    SELECT IDPERSONA FROM CIUDADANOS
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(80);
  BEGIN
   v_fnd:= NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= PERSONAS_GetNomComp(v_bus.IDPERSONA);
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
   END CIUDADANOS_GetNomComp;
  /* ***************************************************************************
   *  Descripcin: Devuelve la edad de un ciudadano
   *  Parametro entrada:
   *      p_id = Identificador a buscar
   *  Devuelve una cadena con nombre completo de tiudad
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         24-11-2014  Creacin funcin    
   ****************************************************************************/
  
  FUNCTION CIUDADANOS_GetEdad(p_id IN CIUDADANOS.ID%TYPE)
   RETURN INTEGER 
  IS
  CURSOR c_bus IS
    SELECT IDPERSONA FROM CIUDADANOS
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  INTEGER;
  BEGIN
   v_fnd:= NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= PERSONAS_GetEdad(v_bus.IDPERSONA);
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
   END CIUDADANOS_GetEdad;
 
  
/* ***************************************************************************
   *  Descripcin: Devuelve el pais de un ciudadano
   *  Parametro entrada:
   *      p_idciu = Identificador de ciudadano
   *
   *  Devuelve el cdigo de pais del centro en el que est registrado el 
   *  ciudadano.
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         07-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION CIUDADANOS_GetPais(p_idciu IN CIUDADANOS.ID%TYPE)
   RETURN PAISES.COD%TYPE 
   IS
  CURSOR c_bus IS
    SELECT CE.CODPAIS FROM CIUDADANOS CI,CENTROS_SALUD CE 
      WHERE CI.ID=p_idciu  
        AND  CI.IDCENTRO = CE.ID;
  v_bus  c_bus%ROWTYPE;
  v_fnd  PAISES.COD%TYPE;
  BEGIN
   v_fnd:=NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd := v_bus.CODPAIS;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END CIUDADANOS_GetPais;
    
   /* ***************************************************************************
   *  Descripcin: Busca centro de salud en tabla CENTROS DE SALUD
   *  Parametro entrada:
   *      p_id = Identificador de centro
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION CENTROS_SALUD_Found( p_id IN CENTROS_SALUD.ID%TYPE)
  RETURN VARCHAR2 IS
  
  CURSOR c_bus IS
    SELECT ID FROM CENTROS_SALUD
       WHERE FECHABAJ IS NULL
       AND ID = p_id;
  
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END CENTROS_SALUD_Found;
/* ***************************************************************************
   *  Descripcin: Busca identificador de centro en tabla  CENTROS DE SALUD
   *  Parametro entrada:
   *      p_codpais = Cdigo de pais 
   *      p_codcentro = Cdigo de centro proporcionado por el centro de salud
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         15-11-2014  Creacin funcin    
   ****************************************************************************/
  FUNCTION CENTROS_SALUD_Found(p_codpais IN CENTROS_SALUD.CODPAIS%TYPE
                              ,p_codcentro IN CENTROS_SALUD.CODCENTRO%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT ID FROM CENTROS_SALUD
      WHERE FECHABAJ IS NULL
        AND CODPAIS = p_codpais
        AND CODCENTRO = p_codcentro;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END CENTROS_SALUD_Found;
  /* ***************************************************************************
   *  Descripcin: Busca centro de salud en tabla CENTROS DE MOTIVOS BAJA
   *  Parametro entrada:
   *      p_id = Identificador de centro
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         01-11-2014  Creacin funcin    
   ****************************************************************************/
  FUNCTION MOTIVOS_BAJA_Found(p_id IN MOTIVOS_BAJA.ID%TYPE)
  RETURN VARCHAR2 IS
  
  CURSOR c_bus IS
    SELECT ID FROM MOTIVOS_BAJA
     WHERE HAB ='S'
       AND ID = p_id;
  
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END MOTIVOS_BAJA_Found;
/* ***************************************************************************
   *  Descripcin: Busca identificador actividad diaria en tabla ACT_DIARIA
   *  Parametro entrada:
   *      p_idciu = Identificador de ciudadano
   *      p_fecha  = Dia de actividad
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         04-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION ACT_DIARIA_Found(p_idciu IN ACT_DIARIA.IDCIU%TYPE
                          ,p_fecha IN ACT_DIARIA.FECHA%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT IDCIU FROM ACT_DIARIA
      WHERE IDCIU = p_idciu
        AND FECHA = p_fecha;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END ACT_DIARIA_Found;
  
  /* ***************************************************************************
   *  Descripcin: Obtiene una fila de la tabla ACT_DIARIA
   *  Parametro entrada:
   *      p_idciu = Identificador de ciudadano
   *      p_anio  = Ao historia salud
   *  Devuelve 
   *           - Linea, si encontrada
   *           - NULL, si no encontrada
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         15-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION ACT_DIARIA_GetRow(p_idciu IN ACT_DIARIA.IDCIU%TYPE
                           ,p_fecha IN ACT_DIARIA.FECHA%TYPE)
  RETURN ACT_DIARIA%ROWTYPE IS
  CURSOR c_bus IS
    SELECT * FROM ACT_DIARIA
       WHERE IDCIU = p_idciu
        AND FECHA = p_fecha;
  v_bus  c_bus%ROWTYPE;
  v_fnd  ACT_DIARIA%ROWTYPE;
  BEGIN
   v_fnd := NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= v_bus;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END ACT_DIARIA_GetRow;
  
  /* ***************************************************************************
   *  Descripcin: Busca identificador actividad diaria en tabla HIS_SALUD
   *  Parametro entrada:
   *      p_idciu = Identificador de ciudadano
   *      p_anio  = Ao historia salud
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         10-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION HIS_SALUD_Found(p_idciu IN HIS_SALUD.IDCIU%TYPE
                         ,p_anio IN HIS_SALUD.ANIO%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT IDCIU FROM HIS_SALUD
      WHERE IDCIU = p_idciu
        AND ANIO = p_anio;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END HIS_SALUD_Found;
   /* ***************************************************************************
   *  Descripcin: Busca historia salud por id en tabla HIS_SALUD
   *  Parametro entrada:
   *      p_id = Identificador de historia salud
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         10-10-2014  Creacin funcin    
   ****************************************************************************/
  FUNCTION HIS_SALUD_Found(p_id IN HIS_SALUD.ID%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT ID FROM HIS_SALUD
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END HIS_SALUD_Found;

  /* ***************************************************************************
   *  Descripcin: Obtiene ao correspondiente id de la tabla HIS_SALUD
   *  Parametro entrada:
   *      p_id = Identificador de fila
   *  Devuelve 
   *           - Ao,  si encontrada
   *           - NULL, si no encontrada
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         15-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION HIS_SALUD_GetAnio(p_id IN HIS_SALUD.ID%TYPE)
  RETURN HIS_SALUD.ANIO%TYPE IS
  CURSOR c_bus IS
    SELECT ANIO FROM HIS_SALUD
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  HIS_SALUD.ANIO%TYPE;
  BEGIN
   v_fnd := NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= v_bus.ANIO;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END HIS_SALUD_GetAnio;
  
  
  /* ***************************************************************************
   *  Descripcin: Obtiene identificador ciudadano correspondiente id de la
   *  tabla HIS_SALUD.
   *  Parametro entrada:
   *      p_id = Identificador de fila
   *  Devuelve 
   *           - Identificador ciudadano, si encontrada
   *           - NULL, si no encontrada
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         15-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION HIS_SALUD_GetIdCiu(p_id IN HIS_SALUD.ID%TYPE)
  RETURN HIS_SALUD.IDCIU%TYPE IS
  
  CURSOR c_bus IS
    SELECT IDCIU FROM HIS_SALUD
      WHERE ID = p_id;
      
  v_bus  c_bus%ROWTYPE;
  v_fnd  HIS_SALUD.IDCIU%TYPE;
  BEGIN
   v_fnd := NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= v_bus.IDCIU;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END HIS_SALUD_GetIdCiu; 

  /* ***************************************************************************
   *  Descripcin: Obtiene una fila de la tabla HIS_SALUD
   *  Parametro entrada:
   *      p_idciu = Identificador de ciudadano
   *      p_anio  = Ao historia salud
   *  Devuelve 
   *           - Linea, si encontrada
   *           - NULL, si no encontrada
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         15-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION HIS_SALUD_GetRow(p_idciu IN HIS_SALUD.IDCIU%TYPE
                          ,p_anio IN HIS_SALUD.ANIO%TYPE)
  RETURN HIS_SALUD%ROWTYPE IS
  CURSOR c_bus IS
    SELECT * FROM HIS_SALUD
      WHERE IDCIU = p_idciu
        AND ANIO = p_anio;
  v_bus  c_bus%ROWTYPE;
  v_fnd  HIS_SALUD%ROWTYPE;
  BEGIN
   v_fnd := NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= v_bus;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END HIS_SALUD_GetRow;
  /* ***************************************************************************
   *  Descripcin: Obtiene una fila de la tabla HIS_SALUD
   *  Parametro entrada:
   *      p_id   = Identificador de historia salud en la BD
   *  Devuelve 
   *           - Linea, si encontrada
   *           - NULL, si no encontrada
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         20-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION HIS_SALUD_GetRow(p_id IN HIS_SALUD.ID%TYPE)
  RETURN HIS_SALUD%ROWTYPE IS
  CURSOR c_bus IS
    SELECT * FROM HIS_SALUD
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  HIS_SALUD%ROWTYPE;
  BEGIN
   v_fnd := NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= v_bus;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END HIS_SALUD_GetRow;
   /* ***************************************************************************
   *  Descripcin: Busca si existe asignacin en la tabla HISSALUD_ENF
   *  Parametro entrada:
   *      p_idhis = Identificador de historia salud
   *      p_idenf  = Identificador enfermedad
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         10-10-2014  Creacin funcin    
   ****************************************************************************/
  FUNCTION HISSALUD_ENF_Found(p_idhis IN HIS_SALUD.ID%TYPE
                            , p_idenf IN ENFERMEDADES.ID%TYPE)
  RETURN VARCHAR2 IS 
  CURSOR c_bus IS
    SELECT IDHIS FROM HISSALUD_ENF
      WHERE IDHIS = p_idhis
        AND IDENF = p_idenf;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END HISSALUD_ENF_Found;
 /* ***************************************************************************
   *  Descripcin: Busca enfermedad grave por id en tabla ENFERMEDADES
   *  Parametro entrada:
   *      p_id = Identificador de enfermedad grave
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         10-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION ENFERMEDADES_Found(p_id IN ENFERMEDADES.ID%TYPE)
  RETURN VARCHAR2 IS
  CURSOR c_bus IS
    SELECT ID FROM ENFERMEDADES
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END ENFERMEDADES_Found;
  
 /* ***************************************************************************
   *  Descripcin: Indica si existe  nombre de columna estadistica en 
   *               tabla ENFERMEDADES.
   *  Parametro entrada:
   *      p_colest = nombre de columna estadstica
   *  Devuelve una cadena
   *      Contiene:
   *                'S' - > si encontrado
   *                'N' - > si no encontrado
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         14-11-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION ENFERMEDADES_Found(p_colest IN ENFERMEDADES.COLEST%TYPE)
  RETURN VARCHAR2 IS
  
  CURSOR c_bus IS
    SELECT ID FROM ENFERMEDADES
      WHERE COLEST = p_colest;
  v_bus  c_bus%ROWTYPE;
  v_fnd  VARCHAR2(1);
  BEGIN
   v_fnd:='N';
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:='S';
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END ENFERMEDADES_Found;  
  
/* ***************************************************************************
   *  Descripcin: Devuelve la descripcin de una enfermedad grave
   *  Parametro entrada:
   *      p_id = Identificador a buscar
   *  Devuelve una cadena con la descripcin de la enfermedad grave
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         20-12-2014  Creacin funcin    
   ****************************************************************************/

 FUNCTION ENFERMEDADES_GetByID(p_id IN ENFERMEDADES.ID%TYPE)
  RETURN ENFERMEDADES.DENOM%TYPE IS
  CURSOR c_bus IS
    SELECT DENOM FROM ENFERMEDADES
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  ENFERMEDADES.DENOM%TYPE;
  BEGIN
   v_fnd:= NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= v_bus.denom;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;   
  END ENFERMEDADES_GetByID;
  
  /* ***************************************************************************
   *  Descripcin: Devuelve la columna de estadstica de una enfermedad grave
   *  Parametro entrada:
   *      p_id = Identificador de enfermedad
   *
   *  Devuelve:
   *         - La columna de estadstica de una enfermedad grave, si existe
   *         - NULL, si no existe enfermedad o columna
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         15-10-2014  Creacin funcin    
   ****************************************************************************/
  FUNCTION ENFERMEDADES_GetColEst(p_id IN ENFERMEDADES.ID%TYPE)
  RETURN ENFERMEDADES.COLEST%TYPE
   IS
  CURSOR c_bus IS
    SELECT COLEST FROM ENFERMEDADES 
      WHERE ID = p_id;
      
  v_bus  c_bus%ROWTYPE;
  v_fnd  ENFERMEDADES.COLEST%TYPE;
  BEGIN
   v_fnd:=NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd := v_bus.COLEST;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END ENFERMEDADES_GetColEst;
 
/* ***************************************************************************
   *  Descripcin: Devuelve identificador de registro de tabla EST_ANU_PAI_SALUD
   *  Parametro entrada:
   *      p_anio = Ao estadistico
   *      p_codpais = Cdigo pais
   *
   *  Devuelve el idientificador del registro encontrado.
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         07-10-2014  Creacin funcin    
   ****************************************************************************/
FUNCTION EST_ANU_PAI_SALUD_GetID(p_anio IN EST_ANU_PAI_SALUD.ANIO%TYPE 
                           , p_codpais IN EST_ANU_PAI_SALUD.CODPAIS%TYPE)
  RETURN EST_ANU_PAI_SALUD.ID%TYPE
IS
  CURSOR c_bus IS
    SELECT ID FROM EST_ANU_PAI_SALUD
      WHERE ANIO = p_anio  
        AND  CODPAIS = p_codpais;
        
  v_bus  c_bus%ROWTYPE;
  v_fnd  EST_ANU_PAI_SALUD.ID%TYPE;
  BEGIN
   v_fnd:=NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd := v_bus.ID;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END EST_ANU_PAI_SALUD_GetID;

  /* ***************************************************************************
   *  Descripcin: Devuelve identificador de registro de tabla EST_ANU_SALUD
   *  Parametro entrada:
   *      p_anio = Ao estadistico
   *  Devuelve el idientificador del registro encontrado.
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         12-10-2014  Creacin funcin    
   ****************************************************************************/
FUNCTION EST_ANU_SALUD_GetID(p_anio IN EST_ANU_SALUD.ANIO%TYPE)
  RETURN EST_ANU_SALUD.ID%TYPE
IS
  CURSOR c_bus IS
    SELECT ID FROM EST_ANU_SALUD
      WHERE ANIO = p_anio;
        
  v_bus  c_bus%ROWTYPE;
  v_fnd  EST_ANU_SALUD.ID%TYPE;
  BEGIN
   v_fnd:=NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd := v_bus.ID;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END EST_ANU_SALUD_GetID;

  /* ***************************************************************************
   *  Descripcin: Devuelve la descripcin de un error
   *  Parametro entrada:
   *      p_id = Identificador a buscar
   *  Devuelve una cadena con la descripcin del error
   *
   *  Autor            Fecha creacin/modificacin
   *---------------------------------------------------------------------------
   * Mari Cruz         29-10-2014  Creacin funcin    
   ****************************************************************************/
 FUNCTION ERRORES_GetByID(p_id IN ERRORES.ID%TYPE)
  RETURN ERRORES.DESCRIP%TYPE IS
  CURSOR c_bus IS
    SELECT DESCRIP FROM ERRORES
      WHERE ID = p_id;
  v_bus  c_bus%ROWTYPE;
  v_fnd  ERRORES.DESCRIP%TYPE;
  BEGIN
   v_fnd:= NULL;
   
   OPEN c_bus;
   FETCH c_bus INTO v_bus;
   IF c_bus%FOUND THEN
      v_fnd:= v_bus.descrip;
   END IF;
   CLOSE c_bus;
   
   RETURN v_fnd;
  END ERRORES_GetByID;

END UTILIDADES;
/