/*---------------------------------------------------------
CON EL USUARIO BDSALUD CREAMOS LOS TRIGGERS
PARA EL APLICATIVO Big Data de salud
-----------------------------------------------------------*/
/********************* AL INSERTAR *************************/
--------- PAISES -----------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_PAISES_BI
  BEFORE INSERT ON BDSALUD.PAISES 
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_PAISES_BI;
/
--------- PERSONAS ---------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_PERSONAS_BI
  BEFORE INSERT ON BDSALUD.PERSONAS 
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador si n se proporciona 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_PERSONAS.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_PERSONAS_BI;
/
--------- CENTROS SALUD ----
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_CENTROS_SALUD_BI
  BEFORE INSERT ON BDSALUD.CENTROS_SALUD 
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_CENTROS_SALUD.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_CENTROS_SALUD_BI;
/
----- MOTIVOS BAJA ---------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_MOTIVOS_BAJA_BI
  BEFORE INSERT ON BDSALUD.MOTIVOS_BAJA 
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_MOTIVOS_BAJA.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_MOTIVOS_BAJA_BI;
/
------ CIUDADANOS ----------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_CIUDADANOS_BI
  BEFORE INSERT ON BDSALUD.CIUDADANOS 
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_CIUDADANOS.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_CIUDADANOS_BI;
/
------ HISTORIA SALUD ------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_HIS_SALUD_BI
  BEFORE INSERT ON BDSALUD.HIS_SALUD 
  FOR EACH ROW
  BEGIN  
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_HIS_SALUD.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');  
  END TR_HIS_SALUD_BI;
/
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_HISSALUD_ENF_BI
  BEFORE INSERT ON BDSALUD.HISSALUD_ENF 
  FOR EACH ROW
  BEGIN  
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');  
  END TR_HISSALUD_ENF_BI;
/
------ ENFERMEDADES -------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_ENFERMEDADES_BI
  BEFORE INSERT ON BDSALUD.ENFERMEDADES 
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_ENFERMEDADES.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_ENFERMEDADES_BI;
/
------ ACTIVIDAD DIARIA ----
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_ACT_DIARIA_BI
  BEFORE INSERT ON BDSALUD.ACT_DIARIA 
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
   :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_ACT_DIARIA_BI;
/
------------ ERRORES ----------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_ERRORES_BI
  BEFORE INSERT ON BDSALUD.ERRORES
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_ERRORES.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_ERRORES_BI;
/
------------- LOGS  -------------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_LOGS_BI
  BEFORE INSERT ON BDSALUD.LOGS
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_LOGS.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USULOG:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_LOGS_BI;
/
------------ EST_ANU_PAI_SALUD ----------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_EST_ANU_PAI_SALUD_BI
  BEFORE INSERT ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_EST_ANU_PAI_SALUD.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');
  END TR_EST_ANU_PAI_SALUD_BI;
/
------------ EST_ANU_SALUD ----------
 ----  TRIGGER AL INSERTAR ---
  CREATE OR REPLACE TRIGGER TR_EST_ANU_SALUD_BI
  BEFORE INSERT ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
    -- Alimenta identificador 
    IF :new.ID IS NULL THEN
	     SELECT BDSALUD.SE_EST_ANU_SALUD.nextval INTO :new.ID FROM DUAL;
    END IF;
    -- Alimenta datos auditoria
    :new.USUINS:=SYS_CONTEXT('USERENV','SESSION_USER');    
  END TR_EST_ANU_SALUD_BI;
/

/******************* AL ACTUALIZAR ***********************/
--------- PAISES -----------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_PAISES_BU
  BEFORE UPDATE ON BDSALUD.PAISES 
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;
  END TR_PAISES_BU;
/
--------- PERSONAS ---------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_PERSONAS_BU
  BEFORE UPDATE ON BDSALUD.PERSONAS 
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
     :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
     :new.DATMOD:=SYSDATE;
  END TR_PERSONAS_BU;
/
--------- CENTROS SALUD ----
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_CENTROS_SALUD_BU
  BEFORE UPDATE ON BDSALUD.CENTROS_SALUD 
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;
  END TR_CENTROS_SALUD_BU;
/
----- MOTIVOS BAJA ---------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_MOTIVOS_BAJA_BU
  BEFORE UPDATE ON BDSALUD.MOTIVOS_BAJA 
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;
  END TR_MOTIVOS_BAJA_BU;
/
------ CIUDADANOS ----------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_CIUDADANOS_BU
  BEFORE UPDATE ON BDSALUD.CIUDADANOS 
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
     :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
     :new.DATMOD:=SYSDATE;
  END TR_CIUDADANOS_BU;
/
------ HISTORIA SALUD ------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_HIS_SALUD_BU
  BEFORE UPDATE ON BDSALUD.HIS_SALUD 
  FOR EACH ROW
  BEGIN   
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;  
  END TR_HIS_SALUD_BU;
/
----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_HISSALUD_ENF_BU
  BEFORE UPDATE ON BDSALUD.HISSALUD_ENF 
  FOR EACH ROW
  BEGIN   
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;  
  END TR_HISSALUD_ENF_BU;
/
------  ENFERMEDADES -------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_ENFERMEDADES_BU
  BEFORE UPDATE ON BDSALUD.ENFERMEDADES 
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;
  END TR_ENFERMEDADES_BU;
/
------ ACTIVIDAD DIARIA ----
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_ACT_DIARIA_BU
  BEFORE UPDATE ON BDSALUD.ACT_DIARIA 
  FOR EACH ROW
  BEGIN                  
    -- Alimenta datos auditoria
        :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
        :new.DATMOD:=SYSDATE;                                  
  END TR_ACT_DIARIA_BU;
/  
------------ ERRORES ----------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_ERRORES_BU
  BEFORE UPDATE ON BDSALUD.ERRORES
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;
  END TR_ERRORES_BU;
/

------------ EST_ANU_PAI_SALUD ----------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_EST_ANU_PAI_SALUD_BU
  BEFORE UPDATE ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;
    
  END TR_EST_ANU_PAI_SALUD_BU;
/
------------ EST_ANU_SALUD ----------
 ----  TRIGGER AL ACTUALIZAR ---
  CREATE OR REPLACE TRIGGER TR_EST_ANU_SALUD_BU
  BEFORE UPDATE ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
    -- Alimenta datos auditoria
    :new.USUMOD:=SYS_CONTEXT('USERENV','SESSION_USER');
    :new.DATMOD:=SYSDATE;    
  END TR_EST_ANU_SALUD_BU;
/

/************* ESTADISTICA ANUAL CE *******************/
----  TRIGGER AL ACTUALIZAR COLUMNA CIUSCONA ---
  CREATE OR REPLACE TRIGGER TR_ESTSALUD_CIUSCONA_BU
  BEFORE UPDATE OF CIUSCONA ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN  
   :new.CIUSCONA := ESTADISTICA.ACT_DIARIA_CIUSCONA(:new.ANIO);
  END TR_ESTSALUD_CIUSCONA_BU;
/
 ----  TRIGGER AL ACTUALIZAR COLUMNA CALSCIUS ---
  CREATE OR REPLACE TRIGGER TR_ESTSALUD_CALSCIUS_BU
  BEFORE UPDATE OF CALSCIUS ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
   :new.CALSCIUS := ESTADISTICA.ACT_DIARIA_CALSCIUS(:new.ANIO);
   -- Recupera persona con mximo de caloras
   :new.PERMAXCAL:= ESTADISTICA.ACT_DIARIA_GetPerMaxCal(:new.ANIO); 
  END TR_ESTSALUD_CALSCIUS_BU;
/ 
----  TRIGGER AL ACTUALIZAR COLUMNA PASCIUS ---
  CREATE OR REPLACE TRIGGER TR_ESTSALUD_PASCIUS_BU
  BEFORE UPDATE OF PASCIUS ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
   :new.PASCIUS := ESTADISTICA.ACT_DIARIA_PASCIUS(:new.ANIO);
  END TR_ESTSALUD_PASCIUS_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA HPACIUS ---
  CREATE OR REPLACE TRIGGER TR_ESTSALUD_HPACIUS_BU
  BEFORE UPDATE OF HPACIUS ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
   :new.HPACIUS := ESTADISTICA.ACT_DIARIA_HPACIUS(:new.ANIO);
  END TR_ESTSALUD_HPACIUS_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA ELEVCIUS ---
  CREATE OR REPLACE TRIGGER TR_ESTSALUD_ELEVCIUS_BU
  BEFORE UPDATE OF ELEVCIUS ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
   :new.ELEVCIUS := ESTADISTICA.HIS_SALUD_ELEVCIUS(:new.ANIO);
  END TR_ESTSALUD_ELEVCIUS_BU;  
/
--******* COLUMNAS ENFERMEDADES GRAVES *********
----  TRIGGER AL ACTUALIZAR COLUMNA CIUSECAR ---
  CREATE OR REPLACE TRIGGER TR_ESTSALUD_CIUSECAR_BU
  BEFORE UPDATE OF CIUSECAR ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
    -- Alimenta ciudadanos con enfermedad cardiaca ID = 1
  :new.CIUSECAR := ESTADISTICA.HISSALUD_ENF_GetCiusE(1,:new.ANIO);
  END TR_ESTSALUD_CIUSECAR_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA CIUSECAN ---
  CREATE OR REPLACE TRIGGER TR_ESTSALUD_CIUSECAN_BU
  BEFORE UPDATE OF CIUSECAN ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
   -- Alimenta ciudadanos con enfermedad cancerigena ID = 2
   :new.CIUSECAN := ESTADISTICA.HISSALUD_ENF_GetCiusE(2,:new.ANIO);
  END TR_ESTSALUD_CIUSECAN_BU;  
/
----  TRIGGER AL ACTUALIZAR COLUMNA CIUSEDEG ---
  CREATE OR REPLACE TRIGGER TR_ESTSALUD_CIUSEDEG_BU 
  BEFORE UPDATE OF CIUSEDEG ON BDSALUD.EST_ANU_SALUD
  FOR EACH ROW
  BEGIN
   -- Alimenta ciudadanos con enfermedad degenerativa ID = 3
   :new.CIUSEDEG := ESTADISTICA.HISSALUD_ENF_GetCiusE(3,:new.ANIO); 
  END TR_ESTSALUD_CIUSEDEG_BU;
/

/************ ESTADISTICA ANUAL paises ******************/
----  TRIGGER AL ACTUALIZAR COLUMNA CIUSCONA ---
  CREATE OR REPLACE TRIGGER TR_ESTPAISALUD_CIUSCONA_BU
  BEFORE UPDATE OF CIUSCONA ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
   :new.CIUSCONA := ESTADISTICA.ACT_DIARIA_CIUSCONA(:new.ANIO, :new.CODPAIS);
  END TR_ESTPAISALUD_CIUSCONA_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA CALSCIUS ---
  CREATE OR REPLACE TRIGGER TR_ESTPAISALUD_CALSCIUS_BU
  BEFORE UPDATE OF CALSCIUS ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
   :new.CALSCIUS := ESTADISTICA.ACT_DIARIA_CALSCIUS(:new.ANIO,:new.CODPAIS);     
   -- Recupera persona con mximo de caloras
   :new.PERMAXCAL:=ESTADISTICA.ACT_DIARIA_GetPerMaxCal(:new.ANIO,:new.CODPAIS);
  END TR_ESTPAISALUD_CALSCIUS_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA PASCIUS ---
  CREATE OR REPLACE TRIGGER TR_ESTPAISALUD_PASCIUS_BU
  BEFORE UPDATE OF PASCIUS ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
   :new.PASCIUS := ESTADISTICA.ACT_DIARIA_PASCIUS(:new.ANIO,:new.CODPAIS);
  END TR_ESTPAISALUD_PASCIUS_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA HPACIUS ---
  CREATE OR REPLACE TRIGGER TR_ESTPAISALUD_HPACIUS_BU
  BEFORE UPDATE OF HPACIUS ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
   :new.HPACIUS := ESTADISTICA.ACT_DIARIA_HPACIUS(:new.ANIO,:new.CODPAIS);
  END TR_ESTPAISALUD_HPACIUS_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA ELEVCIUS ---
  CREATE OR REPLACE TRIGGER TR_ESTPAISALUD_ELEVCIUS_BU
  BEFORE UPDATE OF ELEVCIUS ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
   :new.ELEVCIUS := ESTADISTICA.HIS_SALUD_ELEVCIUS(:new.ANIO,:new.CODPAIS);
  END TR_ESTPAISALUD_ELEVCIUS_BU;  
/

--******* COLUMNAS ENFERMEDADES GRAVES *********
----  TRIGGER AL ACTUALIZAR COLUMNA CIUSECAR ---
  CREATE OR REPLACE TRIGGER TR_ESTPAISALUD_CIUSECAR_BU
  BEFORE UPDATE OF CIUSECAR ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
    -- Alimenta ciudadanos con enfermedad cardiaca ID = 1
   :new.CIUSECAR := ESTADISTICA.HISSALUD_ENF_GetCiusE(1,:new.ANIO,:new.CODPAIS);
  END TR_ESTPAISALUD_CIUSECAR_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA CIUSECAN ---
  CREATE OR REPLACE TRIGGER TR_ESTPAISALUD_CIUSECAN_BU
  BEFORE UPDATE OF CIUSECAN ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
   -- Alimenta ciudadanos con enfermedad cancerigena ID = 2
   :new.CIUSECAN := ESTADISTICA.HISSALUD_ENF_GetCiusE(2,:new.ANIO,:new.CODPAIS);
  END TR_ESTPAISALUD_CIUSECAN_BU;
/
----  TRIGGER AL ACTUALIZAR COLUMNA CIUSEDEG ---
  CREATE OR REPLACE TRIGGER TR_ESTPAISALUD_CIUSEDEG_BU
  BEFORE UPDATE OF CIUSEDEG ON BDSALUD.EST_ANU_PAI_SALUD
  FOR EACH ROW
  BEGIN
   -- Alimenta ciudadanos con enfermedad degenerativa ID = 3
   :new.CIUSEDEG := ESTADISTICA.HISSALUD_ENF_GetCiusE(3,:new.ANIO,:new.CODPAIS);  
  END TR_ESTPAISALUD_CIUSEDEG_BU;
/


--  ***********************************************************