DECLARE
v_RSP               VARCHAR2 (500);
v_id                HIS_SALUD.ID%TYPE;
BEGIN
v_RSP := ' ';
---  Control errores en actualizacin centros de salud (Punto 1.4.1.	documentacin) ----
-- Aade centro de salud con codigo centro de salud a null (valor obligatorio)
ACT_SALUD.CENTROS_SALUD_Add('DE', null, 'Centro de salud en Alemania', '325259038', 'fic_mail@hotmail.com ', v_RSP); 
-- Aade centro de salud de pais no encontrado en la BD
ACT_SALUD.CENTROS_SALUD_Add('FF','CSDE0001', 'Centro de salud en Alemania', '325259038', 'fic_mail@hotmail.com ', v_RSP);
-- Aade centro salud con cdigo centro duplicado
ACT_SALUD.CENTROS_SALUD_Add('DE','CSDE0001', 'Centro de salud en Alemania', '325259038', 'fic_mail@hotmail.com ', v_RSP); 
-- Modifica centro salud con identificacin a null (valor obligatorio)
ACT_SALUD.CENTROS_SALUD_Update(null,'Centro de salud en Dinamarca Sur','45325566543','xconfloncw@hotmail.com',v_RSP);
-- Modifica centro salud con identificacin centro de salud no existe en BD
ACT_SALUD.CENTROS_SALUD_Update(999999,'Centro de salud en Dinamarca Sur','45325566543','xconfloncw@hotmail.com',v_RSP);
-- Da de baja centro de salud con identificacin a null (valor obligatorio)
ACT_SALUD.CENTROS_SALUD_Delete(null,to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);
-- Da de baja centro de salud con identificacin centro salud que no existe en BD
ACT_SALUD.CENTROS_SALUD_Delete(999999,to_date('10/27/2014', 'mm/dd/yyyy'),v_RSP);

---  Control errores en actualizacin personas (Punto 1.4.2. documentacin) ----
-- Aade persona con nombre a null (valor obligatorio)
ACT_PERSONA.PERSONAS_Add('40999999Q', NULL, 'RAMIREZ', 'RODRIGUEZ', to_date('12/03/1979', 'mm/dd/yyyy'), 'ES', 'M',v_id, v_RSP);
-- Aade persona con pais no encontrado en la BD
ACT_PERSONA.PERSONAS_Add('40999999Q', 'ROSARIO', 'RAMIREZ', 'RODRIGUEZ', to_date('12/03/1979', 'mm/dd/yyyy'), 'FF', 'M',v_id, v_RSP);
-- Aade persona con identificacin duplicada
ACT_PERSONA.PERSONAS_Add('T00134356', 'TAMYAN', 'QUEPLYN', 'SAFLO', to_date('12/03/1979', 'mm/dd/yyyy'), 'CY', 'M',v_id, v_RSP);
-- Modifica persona con sexo a null (valor obligatorio)
ACT_PERSONA.PERSONAS_Update(15,'T00109289',	'ANTONIO','SOLER','PIZARRO', to_date('24/04/1979','dd/mm/yyyy'), 'CY',	NULL, v_RSP);
-- Modifica persona con pais no encontrado en la BD
ACT_PERSONA.PERSONAS_Update(15,'T00109289',	'ANTONIO','SOLER','PIZARRO', to_date('24/04/1979','dd/mm/yyyy'), 'FF',	'V', v_RSP);
-- Modifica persona con identificacin que no existe en la BD
ACT_PERSONA.PERSONAS_Update(999999,'T00109289',	'ANTONIO','SOLER','PIZARRO', to_date('24/04/1979','dd/mm/yyyy'), 'ES',	'V', v_RSP);
-- Da de baja persona con fecha de baja a null (valor obligatorio)
ACT_PERSONA.PERSONAS_Delete(6, NULL,v_RSP);
-- Da de baja persona con identificacin que no existe en la BD
ACT_PERSONA.PERSONAS_Delete(999999, NULL,v_RSP);

---  Control errores en actualizacin ciudadanos (Punto 1.4.3. documentacin) ----
-- Aade ciudadano con fecha alta a null (valor obligatorio)
ACT_SALUD.CIUDADANOS_Add(7, 10, 'CSES0000000232', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', NULL, v_RSP);
-- Aade ciudadano con persona que est dada de baja en la BD
ACT_SALUD.CIUDADANOS_Add(1, 10, 'CSES0000000232', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
-- Aade ciudadano con centro de salud que est dado de baja en la BD
ACT_SALUD.CIUDADANOS_Add(7, 10, 'CSEE0004', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
-- Aade ciudadano duplicado (persona y centro de salud duplicados)
ACT_SALUD.CIUDADANOS_Add(7, 10, 'CSES0000000232', ' ', NULL, 'fic_mail@idiomas.udea.edu.co ', to_date('10/24/2014', 'mm/dd/yyyy'), v_RSP);
-- Modifica ciudadano con codigo identificacin ciudadano a null (valor obligatorio)
ACT_SALUD.CIUDADANOS_UPDATE(NULL,'CSES0000000270','971676655','776545022','socflo_mail@hotmail.com', to_date('24/10/2014','dd/mm/yyyy'),v_RSP);
-- Modifica ciudadano con codigo identificacin ciudadano que no existe en la BD
ACT_SALUD.CIUDADANOS_UPDATE(999999,'CSES0000000270','971676655','776545022','socflo_mail@hotmail.com', to_date('24/10/2014','dd/mm/yyyy'),v_RSP);
-- Da de baja ciudadano con fecha de baja a null (valor obligatorio)
ACT_SALUD.CIUDADANOS_Delete(107, NULL,1,v_RSP);
-- Da de baja ciudadano con motivo de baja que no existe en la BD
ACT_SALUD.CIUDADANOS_Delete(107, to_date('10/24/2014', 'mm/dd/yyyy'),99,v_RSP);
-- Da de baja ciudadano con cdigo identificacin ciudadano que no existe en la BD
ACT_SALUD.CIUDADANOS_Delete(999999, to_date('10/24/2014', 'mm/dd/yyyy'),1,v_RSP);

-----  Control errores actualizacin actividad diaria (Punto 1.4.4. documentacin) ----
-- Actualiza actividad diaria de ciudadano con pasos a null (valor obligatorio)
ACT_SALUD.ACT_DIARIA_Act(8, to_date('11/05/2013', 'mm/dd/yyyy'), NULL, 1242, 10,v_RSP);
-- Actualiza actividad diaria para ciudadano que no existe en la BD
ACT_SALUD.ACT_DIARIA_Act(99998, to_date('11/05/2013', 'mm/dd/yyyy'), 0, 1242, 10,v_RSP);
-- Actualiza actividad diaria de ciudadano con valor de parmetro caloras en negativo
ACT_SALUD.ACT_DIARIA_Act(9, to_date('11/05/2013', 'mm/dd/yyyy'), 0, -101, 10,v_RSP);
-- Elimina actividad diaria con identificacin ciudadano a null (valor obligatorio)
ACT_SALUD.ACT_DIARIA_Delete(null, to_date('11/05/2013', 'mm/dd/yyyy'),v_RSP);
-- Elimina actividad diaria que no existe en la BD
ACT_SALUD.ACT_DIARIA_Delete(99, to_date('11/05/2010', 'mm/dd/yyyy'),v_RSP);

---  Control errores actualizacin historia salud (Punto 1.4.5. documentacin) ----
-- Actualiza historia salud de ciudadano con parmetro ao a null (valor obligatorio)
ACT_SALUD.HIS_SALUD_Act(9, NULL, 2, 2,v_id,v_RSP);
-- Actualiza historia salud de ciudadano que no existe en la BD
ACT_SALUD.HIS_SALUD_Act(999998, 2013, 2, 2,v_id,v_RSP);
-- Actualiza historia salud de ciudadano con valor de parmetro visitas mdico en negativo
ACT_SALUD.HIS_SALUD_Act(999998, 2013, -2, 2,v_id,v_RSP);
-- Elimina historia salud con identificador a null (valor obligatorio)
ACT_SALUD.HIS_SALUD_Delete(null,v_RSP);
-- Elimina historia salud que no existe en la BD
ACT_SALUD.HIS_SALUD_Delete(999999,v_RSP);
END;

